Codeforces 628 C. Bear and String Distance【贪心】

来源:互联网 发布:c 串口编程实例 编辑:程序博客网 时间:2024/06/11 04:17

C. Bear and String Distance
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Limak is a little polar bear. He likes nice strings — strings of length n, consisting of lowercase English letters only.

The distance between two letters is defined as the difference between their positions in the alphabet. For example, , and .

Also, the distance between two nice strings is defined as the sum of distances of corresponding letters. For example, , and .

Limak gives you a nice string s and an integer k. He challenges you to find any nice string s' that . Find any s' satisfying the given conditions, or print "-1" if it's impossible to do so.

As input/output can reach huge size it is recommended to use fast input/output methods: for example, prefer to usegets/scanf/printf instead of getline/cin/cout in C++, prefer to use BufferedReader/PrintWriter instead ofScanner/System.out in Java.

Input

The first line contains two integers n and k (1 ≤ n ≤ 1050 ≤ k ≤ 106).

The second line contains a string s of length n, consisting of lowercase English letters.

Output

If there is no string satisfying the given conditions then print "-1" (without the quotes).

Otherwise, print any nice string s' that .

Examples
input
4 26bear
output
roar
input
2 7af
output
db
input
3 1000hey
output
-1

题目大意:

给你一个长度为N的字符串,让你找到另外一个字符串长度也是N,使得各个位子上的字符差的和是k.

如果不存在输出-1.


思路:


每个位子进行贪心,从第一个位子向后扫,肯定我们希望前边的字符差尽可能的差的多一些,那么之后的字符是可以和原字符串相等的。

所以我们对每个位子进行枚举,只要k>0.那么我们此时就尽量将字符差拉大,并且控制不超过范围即可。


Ac代码:

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;char a[500000];char ans[500000];int main(){    int n,k;    while(~scanf("%d%d",&n,&k))    {        scanf("%s",a);        for(int i=0;i<n;i++)        {            if(k>0)            {                int tmp=0;                for(int j=1;j<=26;j++)                {                    if(abs(j-(a[i]-'a'+1))>tmp)                    {                        tmp=abs(j-(a[i]-'a'+1));                        ans[i]=j-1+'a';                    }                }                if(k>=tmp)k-=tmp;                else                {                    for(int j=1;j<=26;j++)                    {                        if(abs(j-(a[i]-'a'+1))==k)                        {                            ans[i]=j-1+'a';                        }                    }                    k=0;                }            }            else ans[i]=a[i];        }        if(k>0)printf("-1\n");        else        {            for(int i=0;i<n;i++)printf("%c",ans[i]);        printf("\n");        }    }}











0 0
原创粉丝点击